Page MenuHomePhabricator

[analyzer] Update Fuchsia checker to catch when releasing unowned handles.
ClosedPublic

Authored by isthismyaccount on Dec 28 2020, 11:48 AM.

Details

Summary

Certain Fuchsia functions may return handles that are not owned by the current closure. This adds a check in order to determine when these handles are released.

Diff Detail

Event Timeline

isthismyaccount requested review of this revision.Dec 28 2020, 11:48 AM
isthismyaccount added a reviewer: aabbaabb.
This revision is now accepted and ready to land.Dec 28 2020, 12:59 PM
haowei added inline comments.Jan 5 2021, 7:38 PM
clang/lib/StaticAnalyzer/Checkers/FuchsiaHandleChecker.cpp
22–23

Would you mind updating this ascii art since you added another state in the state machine? It would help other maintainer to understand how the checker works.

Updated flow diagram to include release of unowned handles.

isthismyaccount marked an inline comment as done.Jan 6 2021, 11:15 AM
haowei accepted this revision.Jan 6 2021, 11:28 AM
Herald added a project: Restricted Project. · View Herald TranscriptJan 6 2021, 4:24 PM
Herald added a subscriber: cfe-commits. · View Herald Transcript